<?php
/* Plugin Name: WP Posts-FB Notes
   Plugin URI: http://www.orient.ps
   Description: new facebook/wordpress sync using facebook offical library, no more curl, support all language.
   Version: 0.11
   Author: Mohammed S Shurrab (Dev. Moh sh)
   Author URI: http://www.orient.ps
*/

$wpfb_debug = 0;
global $facebook;

// this function checks for admin pages
if (!function_exists('is_admin_page')) {
  function is_admin_page() {
    if (function_exists('is_admin')) {
      return is_admin();
    }
    if (function_exists('check_admin_referer')) {
       return true;
    } else {
       return false;
    }
  }
}

function wpfb_is_authorized() {
  global $user_level;
  if (function_exists("current_user_can")) {
     return current_user_can('activate_plugins');
  } else {
     return $user_level > 5;
  }
}

function wpfb_connect() {
    global $facebook;

    $appapikey = get_option("wpfb_apikey");
    $appsecret = get_option("wpfb_appsecret");
    $facebook = new Facebook($appapikey, $appsecret);
}

add_action('import_wpfb_comments_hook','wpfb_connect_notes');
function wpfb_connect_notes() {
    global $facebook;
    wpfb_connect();
    wpfb_spider_notes();
}

function wpfb_spider_notes() {
    global $facebook;
    global $wpdb;

    $bp=0;
    $cc=0;
    $test=get_option('wpfb_test');
    $user_id = $facebook->require_login();
    $notes=$facebook->api_client->notes_get($user_id,'');
    foreach($notes as $note){
        if ($post_id = wpfb_isBlog($note['title'])) {
            $bp++;
            $comments=$facebook->api_client->fql_query('SELECT post_id, object_id, fromid, text, time FROM comment WHERE object_id ='.$note['note_id']);
            foreach($comments as $comment){
                if (!wpfb_comment_exist($post_id,$comment)) {
                    if(!$test)
                        wpfb_add_comment($post_id,$comment);
                    else
                        $cc++;
                }
            }
        }
    }
    if($test){
        echo "<h1>Test mode</h1>";
        echo "We found: ".count($notes)." notes<br/>";
        echo $bp." from them found in your blog<br/>";
        echo $cc." new comments found<br/>";
    }
}

function wpfb_add_comment($post_id,$comment) {
    global $facebook;
	$user= $facebook->api_client->users_getInfo($comment['fromid'],'name,email');
	$comment_data = array(); 
	$comment_data["comment_post_ID"] = $post_id;
	$comment_data["comment_author"] =  $user[0]['name'];
	$comment_data["comment_content"] = $comment['text'];
	$comment_data["comment_author_email"] = $user[0]['email'];
	$comment_data["comment_author_IP"] = "127.0.0.1";
	$comment_data["comment_author_url"] = "http://facebook.com/profile.php?id=".$user[0]['uid'];
	$time=date("Y-m-d H:i:s",$comment['time']);
	$comment_data["comment_date"] = $time;
	$comment_data["comment_date_gmt"] = $time;
	$comment_data["comment_approved"] = 0;
	$comment_data["comment_agent"] = "Orient.ps FBNCom";
	$comment_id = wp_insert_comment($comment_data);
        update_comment_meta($comment_id, 'fbuid', $comment['fromid']);
}

function wpfb_isBlog($title) {
   //If this returns a value the post from facebook also exists here
   global $wpdb;

   return $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_title = %s AND post_status = 'publish'",$title));
}

function wpfb_getTitle($id) {
   global $wpdb;

   return $wpdb->get_var($wpdb->prepare("SELECT post_title FROM $wpdb->posts WHERE ID = %s",$id));
}

function wpfb_comment_exist($post_id,$comment) {
  global $facebook;
  global $wpdb;

  if(stripos($comment['text'],"replay from the blog post:"))return true;

  $user= $facebook->api_client->users_getInfo($comment['fromid'],'name,email');
  return $wpdb->get_var($wpdb->prepare("SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID= %s AND comment_author = %s AND comment_content = %s ",$post_id,$user[0]['name'],$comment['text']));
}

register_activation_hook( __FILE__, 'wpfb_activate');
function wpfb_activate() {
   add_option("wpfb_author_email","facebook@philtopia.com",'',"yes");
   add_option("wpfb_start","1",'',"yes");
   add_option("wpfb_auto","0",'',"yes");
   add_option("wpfb_author_profile_url","0",'',"yes");
   add_option("wpfb_apikey","",'',"yes");
   add_option("wpfb_appsecret","",'',"yes");

}

add_action('admin_menu','wpfb_activate_menu');
function wpfb_activate_menu() {
   add_options_page('WP-FB Options', 'WP-FB', 8, 'wpfb.php', 'wpfb_options_menu');
}

//add saving the settings into a function:
function wpfb_save_options() {
   global $error_flag;
   global $wpfb_debug;
	
   if(wpfb_is_authorized()) {
      if (isset($_POST["apikey"]))
         update_option('wpfb_apikey',$_POST["apikey"]);
      else
         update_option('wpfb_apikey',"");  
      if (isset($_POST["appsecret"]))
         update_option('wpfb_appsecret',$_POST["appsecret"]);
      else
         update_option('wpfb_appsecret',"");
      update_option('wpfb_author_email',$_POST["fbemail"]);
      update_option('wpfb_auto',$_POST["auto"]);
      update_option('wpfb_author_profile_url',$_POST["author_profile_url"]);
      if (is_numeric($_POST["page"]))
         update_option('wpfb_page',$_POST["page"]);
      else
         update_option('wpfb_page',"");  
      if(is_numeric($_POST['limit']))
         update_option('wpfb_limit',$_POST['limit']);
      else
         update_option('wpfb_limit',0);
      if(is_numeric($_POST['start']))
         update_option('wpfb_start',$_POST['start']);
      else
         update_option('wpfb_start','1');
      $timer = $_POST['timer'];
      if ($timer != get_option('wpfb_timer')) {
         update_option('wpfb_timer',$_POST['timer']);		 
         wp_clear_scheduled_hook('import_wpfb_comments_hook'); 
         if ($timer == 86400) {			 // Daily
			 wp_schedule_event( time(), 'daily', 'import_wpfb_comments_hook' );
		 } elseif ($timer == 3600) {	 // Hourly
			 wp_schedule_event( time(), 'hourly', 'import_wpfb_comments_hook' );
		 } else {						 // Do nothing!
		 
		 }
      } 
      if ($wpfb_debug == 1)     
         echo "Next timer: " . date("M d Y H:i:s",wp_next_scheduled('import_wpfb_comments_hook'));
         
   } else { 
      echo "<div id='message' class='error fade'><p>Sorry, you don't have permission to view this page.</div>\n";
   }
}

function wpfb_options_menu() {
   //see if the user can see this page.
   if(wpfb_is_authorized()){
      global $wpdb,$error_flag;
      if (isset($_POST['update'])) {
      /*   wpfb_save_options();
         echo "<div id='message' class='updated fade'><p>Updating Comment e-mail addresses</p><div>\n";
         $wpdb->query($wpdb->prepare("UPDATE $wpdb->comments SET comment_Author_email=%s WHERE comment_agent=%s",get_option("wpfb_author_email"), "Mozilla 4.0 (PHP ; Facebook Login Script 0.1 ; PHILTOPIA EDITION")); */
      }

      if (isset($_POST['test'])) {
         //wpfb_save_options();
         echo "<div id='message' class='updated fade'>Test run, All WP blog titles detected in Facebook will be shown along with comments not currently in Database<br/></div>\n";
         update_option('wpfb_test',"1");
         echo "<div id='wpfb_output' style='width:800px;height:300px;overflow:scroll;'>";
         wpfb_connect_notes();  
         echo "</div>";
         update_option('wpfb_test',"0");
      }
 
      if (isset($_POST['manual'])) {
         wpfb_save_options();
         update_option('wpfb_test',"0"); //just incase test crashes and doesnt unset itself
         echo "<div id='message' class='updated fade'><p>Starting manual pull please be patient this may take time...</p></div>\n";
         wpfb_connect_notes();  
         echo "<div id='message' class='updated fade'><p>Completed, check the comments section of Wordpress for any pending comments</p></div>\n";
      }

      if (isset($_POST['save'])) {
         wpfb_save_options();
         if(!$error_flag){
            echo "<div id='message' class='updated fade'><p>Options updated</p></div>\n";
         }
      }
?>
<script src="http://static.ak.connect.facebook.com/js/api_lib/v0.4/FeatureLoader.js.php" type="text/javascript"></script>
<fb:prompt-permission perms="email,offline_access,publish_stream">
Grant permission for status updates
</fb:prompt-permission>
<script type="text/javascript">
    FB.init("<?=get_option("wpfb_apikey")?>", null);
</script>
<div class="wrap">
<h2> WP Posts Facebook Notes</h2>
<form method="POST">
   <h3>Facebook Application</h3>
       Before this plugin can start working, you have to authorize it to access your Facebook application: 
       <br/>
	<fieldset name="apikey">
	<legend>  <?php _e('API Key', 'Localization name') ?>: </legend>
	<input type="text" name="apikey" id="apikey" size="20" value="<?php echo get_option('wpfb_apikey') ?>" /> &nbsp;&nbsp;&nbsp; 
	</fieldset>
	<fieldset name="appsecret">
	<legend>  <?php _e('Application Secret', 'Localization name') ?>: </legend>
	<input type="text" name="appsecret" id="appsecret" size="20" value="<?php echo get_option('wpfb_appsecret') ?>" />
   <h3>Timer Settings</h3>
   Automatic: <select name="timer">
   <option value="86400"<?php if (get_option('wpfb_timer') == 86400) { print " selected"; } ?>>Daily
   <option value="3600"<?php if (get_option('wpfb_timer') == 3600) { print " selected"; } ?>>Hourly
   <option value="0"<?php if (get_option('wpfb_timer') == 0) { print " selected"; } ?>>Never
   </select>
   <br/>
   Auto approve comments: <select name="auto">
   <option value="0" <?php if (get_option('wpfb_auto') == 0) { print " selected"; } ?>> No
   <option value="1" <?php if (get_option('wpfb_auto') == 1) { print " selected"; } ?>> Yes
   </select>
   <br>
   <input type="submit" name="save" value="<?php _e('Save options','Localization name') ?>" class="button-primary"/>
   <input type="submit" name="test" value="<?php _e('Test', 'Localization name') ?> " class="button" />
   <input type="submit" name="manual" value="<?php _e('Manual update','Localization name') ?>" class="button"/>
</form>
</div>
<?php
   } else { 
      echo "<div id='message' class='error fade'><p>Sorry, you don't have permission to view this page.</div>\n";
   }
}


add_action('wp_set_comment_status', 'wpfb_publish',10,2);
function wpfb_publish($comment_id,$comment_status)  {
    global $wpdb;
    global $facebook;
    $comment= get_comment($comment_id);

    if($comment_status != 'approve' || $comment->comment_agent == "Orient.ps FBNCom") return;
    $appapikey = get_option("wpfb_apikey");
    $appsecret = get_option("wpfb_appsecret");
    
    $fb = new Facebook($appapikey, $appsecret);
    $cuser_id = get_comment_meta($comment_id, 'fbuid', true);
    $can=$fb->api_client->users_hasAppPermission('publish_stream',$cuser_id);
    if(! $can)
        $cuser_id = $fb->require_login();
    
    if(! $can)
         $msg="new replay from the blog post:\n author:".$comment->comment_author." \n".$comment->comment_content;
    else
         $msg= $comment->comment_content;
    
    wpfb_connect();
    $user_id = $facebook->require_login();
    $notes=$facebook->api_client->notes_get($user_id,'');

    $post = get_post($comment->comment_post_ID );
    $post_id=0;
    foreach($notes as $note)
        if ($post->post_title == $note['title']) 
            $post_id=$note['uid']."_".$note['note_id'];

//    echo "<script>alert('".$user_id.' , '.$can.' , '.$cuser_id."')</script>";
    if($post_id)
        $facebook->api_client->stream_addComment($post_id, $msg,$cuser_id);
}


add_action('alt_comment_login','wpfb_requers_per');
function wpfb_requers_per() {
	echo 'sssssss';
}

include_once(WP_PLUGIN_DIR."/simple-facebook-connect/facebook-platform/facebook.php");
?>